"use strict";
exports.__esModule = true;
exports.patch = void 0;
var AVAILABLE_PLATFORMS = {
    onWindows: ['win32'],
    onMac: ['darwin'],
    onLinux: ['linux'],
    skipWindows: ['linux', 'darwin'],
    skipMac: ['linux', 'win32'],
    skipLinux: ['darwin', 'win32']
};
var methodOperations = ['skip', 'only'];
function patch(currentPlatform) {
    function newDefinition(method, expectedPlatform, fallbackImplem) {
        var _a;
        if (((_a = AVAILABLE_PLATFORMS[expectedPlatform]) === null || _a === void 0 ? void 0 : _a.indexOf(currentPlatform)) !== -1) {
            return method;
        }
        else {
            return fallbackImplem;
        }
    }
    ;
    Object.keys(AVAILABLE_PLATFORMS).forEach(function (platform) {
        ;
        [describe, it, test].forEach(function (method) {
            method[platform] = newDefinition(method, platform, method.skip);
            method[platform].each = newDefinition(method.each, platform, method.skip.each);
            methodOperations.forEach(function (mode) {
                method[platform][mode] = newDefinition(method[mode], platform, method.skip);
                method[platform][mode].each = newDefinition(method[mode].each, platform, method.skip.each);
            });
        });
    });
}
exports.patch = patch;
